if(typeof Prototype!=='undefined' && typeof YAHOO!=='undefined'){
	WMS.Users = Class.create({},{
            syncGoogleAuthUrlAvailable: false,
            syncGoogleAuthUrl: '',

            office365AuthUrlAvailable: false,
            office365AuthUrl: '',

            zohoCrmAuthUrlAvailable: false,
            zohoCrmAuthUrl: '',

		initialize: function(divTable, fileAjaxUrl, varsPhp){

			ap_showWaitMessage('waitDiv', 1);

			this.divTable = divTable;
			this.varsPhp = varsPhp;
			this.DataTable  = YAHOO.widget.DataTable;
			this.table = null;
			this.modwin = null;
			this.modsecwin = null;

			this.usSyncSettingsAndMap = this.varsPhp.usSyncSettingsAndMap;
			this.usSyncFields = this.varsPhp.usSyncFields;

			return this.table;
		},

		activateButtons: function(){
            const uInviteXbees = document.getElementById('uInviteXbees');
			var butarr = [];
        	if(this.varsPhp.is_userdir_present) {
        		butarr = [1, 2, 3, 4, 5, 6];
        		if(this.varsPhp.pbx_net_mode){
        			butarr[butarr.length] = 7;
        		}
        	} else {
        		butarr = [1, 2, 3, 4, 5];
        		if(this.varsPhp.pbx_net_mode){
        			butarr[butarr.length] = 6;
        		}
        	}

            if(! this.varsPhp.perm.add_remove_users) {
                butarr.splice(1,1);
            }

            activateButtons(this.divTable+'_pnl', butarr);
            if (!this.varsPhp.isXbeesEnable) {
                uInviteXbees.setAttribute('disabled', 'disabled');
            }
		},

		deactivateButtons: function(){
			var butarr = [];
        	if(this.varsPhp.is_userdir_present) {
        		butarr = [1, 2, 3, 4, 5, 6];
        		if(this.varsPhp.pbx_net_mode){
        			butarr[butarr.length] = 7;
        		}
        	} else {
        		butarr = [1, 2, 3, 4, 5];
        		if(this.varsPhp.pbx_net_mode){
        			butarr[butarr.length] = 6;
        		}
        	}

            if (this.table.getSelectedRows().length == 0) {
                deactivateButtons(this.divTable+'_pnl', butarr);
            }
		},

		buildQueryString: function (state,dt) {
			ap_showWaitMessage('waitDiv', 1);

		    var str = '';

		    if(state.pagination){
		    	str = "&startIndex=" + state.pagination.recordOffset +
	               "&results=" + state.pagination.rowsPerPage ;
		    }
		    else{
		    	str = "&startIndex=" + state.recordOffset +
	               "&results=" + state.rowsPerPage ;
		    }

		    var sortedBy = {};
		    if(state.sortedBy){

	    		var sDir = (state.sortedBy.dir === this.DataTable.CLASS_ASC) ? "asc" : "desc";

	    		sortedBy  = {key:state.sortedBy.key, dir: sDir};
	    	}
	    	else{
	    		sortedBy = {key:'', dir:'asc'}
	    	}

		    var search = '';
		    if(this._livesearchElm && this._livesearchElm.value){
		    	search = this._livesearchElm.value;
		    }

		    str += "&sortKey=" + sortedBy.key +
            "&sortDir=" + sortedBy.dir +
            "&search="+search;

		    if (this.varsPhp.pbx_net_mode && this._changePbxElm && this._changePbxElm.value){
	    		str += "&pbxSerial=" + this._changePbxElm.value;
	    	}

		    return str;
	    },

		reloadTable: function(){

			var closeDialog = true;

			var Obj = this.table.getState();
			if(arguments[1]){
				Obj = arguments[1];
			}

			if(arguments[0] == 1){
				Obj.pagination.recordOffset = 0;
			}
			else if(arguments[0] == 'noClose'){
				closeDialog = false;
			}

			this.keyupLiveSearch = false

			this.table.getDataSource().sendRequest(this.buildQueryString(Obj, this.table), {
										success: function(sRequest , oResponse , oPayload){
											if(this.keyupLiveSearch){
												// if new word in live search
												return;
											}
											oPayload = this.table.doBeforeLoadData (sRequest, oResponse, oPayload);

											if(oPayload.totalRecords <= oPayload.pagination.recordOffset ){
												oPayload.pagination.recordOffset = parseInt((oPayload.totalRecords-1)/oPayload.pagination.rowsPerPage)*oPayload.pagination.rowsPerPage;
												oResponse.meta.startIndex = oPayload.pagination.recordOffset;
											}

											this.table.onDataReturnInitializeTable(sRequest , oResponse , oPayload);

											if(this.modwin && closeDialog){
								            	this.modwin.close();
								            	this.modwin = null;
								            }
											this.deactivateButtons();

										}.bind(this) ,
										scope: this.table
									});

		},

		unselectForPasswords: function(selectedRows=[]){

		    var admin_is_present = false;
		    var errors = [];

		    if (this.varsPhp.current_admin == 'admin'){
		        $A(selectedRows).each(function(record){
		            if (record['name'].toLowerCase() == this.varsPhp.current_admin) {
		                admin_is_present = true;
		            }
		        }.bind(this));
		        if (admin_is_present){
		            $A(selectedRows).each(function(record){
		                if (record['name'].toLowerCase() != this.varsPhp.current_admin) {
		                    errors.push(record.getData('cn'));
		                }
		            }.bind(this));
		        }
		    }else{
		        $A(selectedRows).each(function(record){
		            if (record['name'].toLowerCase() == this.varsPhp.current_admin) {
		                admin_is_present = true;
		            }
		        }.bind(this));
		        if (admin_is_present){
		            $A(selectedRows).each(function(record){
		                if (record['name'].toLowerCase() != this.varsPhp.current_admin) {
		                    errors.push(record['name']);
		                }
		            }.bind(this));
		        }else{
		            $A(selectedRows).each(function(record){
		                if (record['name'].toLowerCase() != this.varsPhp.current_admin && (record['name'].toLowerCase() == 'admin' || record['role'] == 'admin')) {
		                	errors.push(record['name']);
		                }
		            }.bind(this));
		        }
		    }

		    if(errors.length>0){
		        setError('warning', gl_translation['aclpbx.NoPermissionForUsers'] + ':<br />'+errors.join("<br />"));
		    }
		},

		editUserPreferences: function(selectedRows) {
		    var userids = this.getSelectedForAclOnlyThatPbx(selectedRows);
		    if (userids == "0") return false;

		    windowop_div("features/features_user.php?userid=" + userids + "&admin=1", 650);

		    return ;
		},

		getSelectedForAclOnlyThatPbx: function (selectedRows=[]){
		    // todo: get only one record
            const pbxDn = this.varsPhp.pbxdn;
            const alienusers = [];

            const requestString = selectedRows.reduce((acc, record) => {
                if (record['pbxDn'] !== pbxDn) {
                    alienusers.push(record);
                } else {
                    acc.push(record['id']);
                }
                return acc;
            }, []).sort().join('|') || '0';

		    if (alienusers.length != 0) {
		        var errstr = gl_translation['aclpbx.impossibleToEditPrefsForRemoteUsers'] + ': ' + $A(alienusers).collect(function(row){
		            return `${row['name']} [${row['extension']}] - ${row['pbx']}`;
		        }).join(', ');

		        setError('notification', errstr.truncate(150));
		    }

		    return requestString || "0";
		},

		sendInviteXbees: function(selectedRows=[]) {

            const usersByLanguage = this.getSelectedUsersByLanguages(selectedRows)
			let no_email = [];

            selectedRows.forEach(function(record){
                if(!record['email']){
                    no_email.push(record['name']);
                }
            })

			if(no_email.length>0) {
				setError('error', gl_translation['aclpbx.NoEmailError'] + no_email.join(', '));
			}

            for(const language in usersByLanguage) {
                ap_showWaitMessage('waitDiv', 1);
                const userids = usersByLanguage[language];
                new Ajax.Request('aclpbx/index.php?lang=' + language, {
                    method: 'post',
                    parameters: {
                        userid: userids.sort().join('|') || "0",
                        action: 'sendWelcomeEmailXbees'
                    },
                    onComplete: () => {
                        ap_showWaitMessage('waitDiv', 0);
                    }
                });
            }
		},

        sendWelcome: async function(selectedRows = []) {

            this.unselectForPasswords();

            const usersByLanguage = this.getSelectedUsersByLanguages(selectedRows)
            const sendEmailByLang = (language, userids) => {
                return new Promise((resolve, reject) => {
                    let content = '';
                    new Ajax.Request(('data/templates/WelcomeMailTemplate.php?lang=' + language) ,{
                        onComplete: function(transport) {
                            //Show loader (??)
                            ap_showWaitMessage('waitDiv', 0);

                            if(transport) {
                                //Save html template from the response
                                content = transport.responseText;

                                let frame = '<iframe id="iframe_box" src="about:blank" style="width: 684px; height: 480px;"></iframe>'
                                this.showDialog(686, 480, frame, function(){

                                    let no_email = [];

                                    selectedRows.forEach(function(record){
                                        const uid = record['id'];
                                        if(userids.indexOf(uid) !== -1) {
                                            if( ! record['email']){
                                                no_email.push(record['name']);
                                            }
                                        }
                                    })

                                    if(no_email.length>0){//Insert email address for user(s)
                                        setError('error', gl_translation['aclpbx.NoEmailError'] + no_email.join(', '));
                                    }

                                    const iframe = document.getElementById('iframe_box').contentWindow.document;

                                    // get template from iframe
                                    const serializer = new XMLSerializer();
                                    const mailTmpl = serializer.serializeToString(iframe);

                                    ap_showWaitMessage('waitDiv', 1);

                                    new Ajax.Request('aclpbx/index.php',{
                                        method: 'post',
                                        parameters: {
                                            userid: userids.sort().join('|') || "0",
                                            action: 'sendWelcomeEmail',
                                            template: mailTmpl
                                        }, //$F('email_tpl')},
                                        onComplete: function(t) {
                                            ap_showWaitMessage('waitDiv', 0);
                                            this.modwin.close();
                                            this.modwin = null;
                                            setTimeout(function () {
                                                resolve();
                                            }, 100)
                                        }.bind(this)
                                    });
                                }, false, true, function () {
                                    setTimeout(function () {
                                        resolve();
                                    }, 100)
                                }).setHeader(gl_translation['aclpbx.editEmailBody']);

                                // hack for once remove empty strings
                                let runOnce;

                                // open template in iframe for save all html tags
                                let iframe = document.getElementById('iframe_box').contentWindow.document;
                                iframe.open();
                                iframe.write(content);
                                iframe.close();

                                let edititableTmpl = iframe.getElementById('tmpl_data');
                                edititableTmpl.addEventListener('click', function() {

                                    let tmplContentDiv = iframe.getElementById('tmpl_content');
                                    let tmplContent = tmplContentDiv.innerHTML;
                                    // change <br> to '\n' and remove empty lines
                                    tmplContent = tmplContent.replace(/<br ?\/?>/g, '\n');

                                    // hack
                                    if (runOnce === undefined) {
                                        tmplContent = tmplContent.replace(/\n\n/g, '\n');
                                        runOnce = true;
                                    }

                                    // prepare second dialog for edit customer data
                                    let content = '<textarea id="email_tpl" style="margin: 5px; width: 475px;height:335px">' + tmplContent  + '</textarea>';

                                    this.showSecondDialog(500, 400, content, function(){

                                        var customData = $F('email_tpl');
                                        // change '\n' to <br>
                                        customData = customData.split('\n').join('<br />');
                                        tmplContentDiv.innerHTML = customData;

                                        // close dialog;
                                        this.modsecwin.close();
                                        this.modsecwin =null;

                                    }, false, true).setHeader(gl_translation['aclpbx.editEmailBody']);
                                }.bind(this), false);
                            }
                            else {
                                reject();
                            }
                        }.bind(this)
                    });
                })
            }

            for(const lang in usersByLanguage) {
                await sendEmailByLang(lang, usersByLanguage[lang]);
            }
		},

		getSelectedUsers: function(){
		    var tbl = this.table;
		    var acl_id = 'uid';

		    var selected = tbl.getSelectedRows() || [];
		    var request_string = selected.inject([],function(records, row, iter){
		        var record = tbl.getRecord(row);
		        return records.add(record.getData(acl_id));
		    }).sort().join('|') || "0";
		    return request_string;
		},

        getSelectedUsersByLanguages: function (selectedRows = []) {
            let result = {};

            selectedRows.forEach(function (record) {
                const preferredLanguage = record['language'];
                if (!result.hasOwnProperty(preferredLanguage)) {
                    result[preferredLanguage] = [];
                }
                result[preferredLanguage].push(record['id'])
            });
            return result;
        },

		moveUsersPbx: function(selectedRows=[]){
            const userids = selectedRows.map((row) => row['id']).sort().join('|');
		    if (!userids) return false;

		    var content = '<div style="padding:10px;"><p>'+gl_translation['multipbx.SelectNewOwner']+'</p>'+
		    			  '<form onsubmit="return false"><select id="newPbx"></select></form>'+
		    			  '<p>'+gl_translation['multipbx.WarningMovingSettings']+'</p></div>';

			this.showDialog(400, 120, content, function(){

			    ap_showWaitMessage('waitDiv', 1);
			    new Ajax.Request('aclpbx/index.php',{
			        method: 'post',
			        parameters: {userid: userids, action: 'moveUsers', new_pbx: $F('newPbx')},
			        onSuccess: function(transport) {
			        	var butarr = [1, 2, 3, 4, 5];
                		if(this.varsPhp.pbx_net_mode){
                			butarr[butarr.length] = 6;
                		}
                        deactivateButtons(this.divTable+'_pnl', butarr);
			            if(transport.responseText != 'OK'){
			                setError('error',  transport.responseText);
			            }
			        }.bind(this),
			        onComplete: () => {
                        this.modwin.close()
                        this.modwin = null;
                        dispatchEvent(new Event('userFormSaved'));
                    }
			    });
			}).setHeader(gl_translation['multipbx.SelectNewOwnerTitle']);

		    var $select = $('newPbx');
		    $select = values.jsonpbxes.BODY.pbxs.inject($select,function(accum,pbx){
		        var opt = new Element('option');
		        opt.value     = pbx.pbxSerial;
		        opt.innerHTML = pbx.pbxDomain + ' ('+ pbx.pbxIp +')';
		        if(pbx.pbxSerial == this.varsPhp.pbxSerial){
		            opt.writeAttribute('selected', 'selected');
		        }
		        accum.insert(opt);
		        return accum;
		    }.bind(this));
		},

		uExportCSV: function() {
		    document.location="aclpbx/index.php?export_users_csv=1";
		},

		usSyncShowWindow: function() {

			this.uSyncUpdater;
			this.uSyncCurrBackend;

			var button = '<div id="users_sync_div_buttons_settings">' +
						 	'<input id="uImportDryRun" type="button" class="but20" value="' + gl_translation['buttons.ImportDryRun'] + '"/>' +
						 	'<input id="uImportDryRunVerbose" style="display:none" type="button" class="but20" value="' + gl_translation['buttons.ImportDryRunVerbose'] + '"/>' +
						 	'<input id="uImport" type="button" class="but20" value="' + gl_translation['buttons.SaveAndImport'] + '"/>' +
						 	'<input id="uSyncDoSave" type="button" class="but20" value="' + gl_translation['buttons.Save'] + '"/>' +
						 	'<input id="saveUserButCancel" type="button" value="'+(gl_translation['button.Cancel'] || 'Cancel')+'" class="but20" />' +
						 '</div>' +
						 '<div style="display:none;" id="users_sync_div_buttons_test">' +
						 	'<input id="us_btn_back" type="button" class="but20" value="' + gl_translation['buttons.Back'] + '"/>' +
						 '</div>';

			this.showDialog(760, 565, $('users_sync_div').innerHTML.interpolate({'hash': 'id'}), false, button).setHeader(gl_translation['aclpbx.usersImport'])

			$('uImportDryRun').onclick = this.uSyncDoSync.bind(this,'yes','no');
		    $('uImportDryRunVerbose').onclick = this.uSyncDoSync.bind(this,'yes','yes');
		    $('uImport').onclick = this.uSyncDoSync.bind(this,'no','no');
		    $('uSyncDoSave').onclick = this.uSyncDoSave.bind(this);
		    $('us_btn_back').onclick = this.uSyncBack.bind(this);

		    this.usSyncSetFrom({});

		    Event.observe($('u_s_backend_backend'),'change',function(event){
		    	this.uSyncChangeBackend(Event.element(event).value);
		    }.bind(this));

		    Event.observe($('u_s_backend_csv_import_type'),'change',function(event){
		    	this.uSyncChangeCsvImportType(Event.element(event).value);
		    }.bind(this));

		    Event.observe($('us_recurrent_on'),'click',function(event){
		    	this.uSyncToggleRecurrentJob(Event.element(event),'us_recurrent_interval','us_recurrent_email');
		    }.bind(this));

		    Event.observe($('u_s_backend_office365_login'),'click',this._onClickOffice365Login.bind(this));
		    Event.observe($('u_s_backend_office365_logout'),'click',this._onClickOffice365Logout.bind(this));

		    Event.observe($('u_s_backend_zohoCrm_login'),'click',this._onClickZohoCrmLogin.bind(this));
		    Event.observe($('u_s_backend_zohoCrm_logout'),'click',this._onClickZohoCrmLogout.bind(this));

		    Event.observe($('u_s_backend_google_login'),'click',this._onClickGoogleLogin.bind(this));
		    Event.observe($('u_s_backend_google_logout'),'click',this._onClickGoogleLogout.bind(this));

		    $$('.uSyncToggleMapAttr').each(function(e){
		    	Event.observe(e,'click',function(event){
		    		this.uSyncToggleMapAttr(Event.element(event), Event.element(event).id.slice(0,-3));
		    	}.bind(this));
		    }.bind(this));
		},

		_onClickOffice365Login: function(event){

            window.callbackOffice365FunctionContacts = this._onOffice365LoginCallback.bind(this);

            if (this.office365AuthUrlAvailable) {
            	window.open(
            			this.office365AuthUrl,
                		"Office365 sing on",
                		"location=0,status=0,scrollbars=0,width=800,height=500"
                );
            } else {
                setError('error', 'Office365 Auth url unavailable');
            }
		},

		_onClickZohoCrmLogin: function(event){
            window.callbackZohoCrmFunctionContacts = this._onZohoCrmLoginCallback.bind(this);

            if (this.zohoCrmAuthUrlAvailable) {
            	window.open(
            			this.zohoCrmAuthUrl,
                		"ZohoCRM sing on",
                		"location=0,status=0,scrollbars=0,width=800,height=500"
                );
            } else {
                setError('error', 'ZohoCrm Auth url unavailable');
            }
		},

		_onClickOffice365Logout: function(event){
			$('u_s_backend_office365_mail').value = '';
			$('u_s_backend_office365_mail_text').innerHTML = '';
			$('u_s_backend_office365_received_token_time').value = '';
			$('u_s_backend_office365_access_token').value = '';
			$('u_s_backend_office365_token_type').value = '';
			$('u_s_backend_office365_expires_in').value = '';
			$('u_s_backend_office365_id_token').value = '';
			$('u_s_backend_office365_id_token_expires_in').value = '';
			$('u_s_backend_office365_refresh_token').value = '';
			$('u_s_backend_office365_logout').hide();
			$('u_s_backend_office365_login').show();

			this.uSyncDoSave();
		},

		_onClickZohoCrmLogout: function(event){
            var parameters = {
                refresh_token: $('u_s_backend_zohoCrm_refresh_token').value,
                api_domain: $('u_s_backend_zohoCrm_api_domain').value,
                action: 'zohoCrm_revoke_token'
            };

            new Ajax.Request('aclpbx/index.php',{
                method: 'post',
                parameters: parameters,
                onSuccess: function(transport) {

                    urls[type] = transport.responseJSON;
                    success(urls[type]);
                },
                onFailure: function (transport) {
                    error(transport.responseJSON);
                }
            });

			$('u_s_backend_zohoCrm_full_name').value = '';
			$('u_s_backend_zohoCrm_full_name_text').innerHTML = '';
			$('u_s_backend_zohoCrm_received_token_time').value = '';
			$('u_s_backend_zohoCrm_access_token').value = '';
			$('u_s_backend_zohoCrm_token_type').value = '';
			$('u_s_backend_zohoCrm_expires_in').value = '';
			$('u_s_backend_zohoCrm_refresh_token').value = '';
			$('u_s_backend_zohoCrm_location').value = '';
			$('u_s_backend_zohoCrm_api_domain').value = '';
            $('u_s_backend_zohoCrm_accounts_server').value = '';
			$('u_s_backend_zohoCrm_logout').hide();
			$('u_s_backend_zohoCrm_login').show();

			this.uSyncDoSave();
		},

		_onOffice365LoginCallback: function(result){
			if(!result){
				// error
				return;
			}
			if(result.error && result.error != '' && result.error_description){
				if(result.error_description){
					setError('error', result.error_description);
				}else{
					// unknow
				}
			}else if(result.token && result.userInfo){
				this._onOffice365LoadToken(result);
			}
		},

		_onZohoCrmLoginCallback: function(result){
			if(!result){
				// error
				return;
			}
			if(result.error && result.error != '' && result.error_description){
				if(result.error_description){
					setError('error', result.error_description);
				}else{
					// unknow
				}
			}else if(result.token && result.userInfo){
				this._onZohoCrmLoadToken(result);
                this.uSyncDoSave.bind(this)
			}
		},

		_onOffice365LoadToken: function(result){

			getOffice365AuthUrl('users', function (response) {
                this.office365AuthUrlAvailable = true;
                this.office365AuthUrl = response.url;

                if(result.userInfo && result.userInfo.preferred_username) {
                    $('u_s_backend_office365_mail').value = result.userInfo.preferred_username;
                    $('u_s_backend_office365_mail_text').innerHTML = result.userInfo.preferred_username;
                }
                if(result.token && result.token.id_token){
                	$('u_s_backend_office365_received_token_time').value = result.token.received_token_time;
                    $('u_s_backend_office365_access_token').value = result.token.access_token;
                    $('u_s_backend_office365_token_type').value = result.token.token_type;
                    $('u_s_backend_office365_expires_in').value = result.token.expires_in;
                    $('u_s_backend_office365_id_token').value = result.token.id_token;
                    $('u_s_backend_office365_id_token_expires_in').value = result.token.id_token_expires_in;
                    $('u_s_backend_office365_refresh_token').value = result.token.refresh_token;
                    $('u_s_backend_office365_logout').show();
                    $('u_s_backend_office365_login').hide();
                }

            }.bind(this));
		},

        _onZohoCrmLoadToken: function(result){
			getZohoCrmAuthUrl('ZohoCRM.users.ALL', function (response) {
                this.zohoCrmAuthUrlAvailable = true;
                this.zohoCrmAuthUrl = response.url;

                if(result.userInfo && result.userInfo.full_name) {
                    $('u_s_backend_zohoCrm_full_name').value          = result.userInfo.full_name;
                    $('u_s_backend_zohoCrm_full_name_text').innerHTML = result.userInfo.full_name;
                }
                if (result.token && result.token.access_token) {
                	$('u_s_backend_zohoCrm_received_token_time').value = result.token.received_token_time;
                    $('u_s_backend_zohoCrm_access_token').value        = result.token.access_token;
                    $('u_s_backend_zohoCrm_token_type').value          = result.token.token_type;
                    $('u_s_backend_zohoCrm_expires_in').value          = result.token.expires_in;
                    $('u_s_backend_zohoCrm_api_domain').value          = result.token.api_domain;
                    $('u_s_backend_zohoCrm_refresh_token').value       = result.token.refresh_token;
                    $('u_s_backend_zohoCrm_accounts_server').value     = result.token.accounts_server;

                    if (result.token.location) {
                        $('u_s_backend_zohoCrm_location').value = result.token.location;
                    } else {
                        $('u_s_backend_zohoCrm_location').value = this.usSyncSettingsAndMap['settings']['zohoCrm']['location'];
                    }

                    $('u_s_backend_zohoCrm_logout').show();
                    $('u_s_backend_zohoCrm_login').hide();
                }

            }.bind(this));
		},

		_onClickGoogleLogin: function(event) {
                    var windowOpen = function (syncGoogleAuthUrl) {
                        window.open(
                            syncGoogleAuthUrl,
		            "Google sing on",
		            "location=0,status=0,scrollbars=0,width=800,height=500"
                        );
                    };

                    window.callbackFunctionUsers = this._onGoogleLoginCallback.bind(this);

                    if (this.syncGoogleAuthUrlAvailable) {
			windowOpen(this.syncGoogleAuthUrl);
                    } else {
                        setError('error', 'Google Auth url unavailable');
                    }
		},

		_onClickGoogleLogout: function(event){
			$('u_s_backend_google_mail').value = '';
			$('u_s_backend_google_mail_text').innerHTML = '';
			$('u_s_backend_google_received_token_time').value = '';
			$('u_s_backend_google_access_token').value = '';
			$('u_s_backend_google_token_type').value = '';
			$('u_s_backend_google_expires_in').value = '';
			$('u_s_backend_google_refresh_token').value = '';
			$('u_s_backend_google_phonebooks').value = '';
			$('u_s_backend_google_logout').hide();
			$('u_s_backend_google_login').show();

			this.uSyncDoSave();
		},

		_onGoogleLoginCallback: function(result){
                    console.log('_onGoogleLoginCallback', result)
                    if (!result) {
                        // error
                        return;
                    }

                    if (result.error && result.error != '' && result.error_description) {
                        if (result.error_description) {
                            setError('error', result.error_description);
                        } else {
                            // unknow
                        }
                    } else if(result.token && result.userInfo){
                        this._tryToSync(result);
                    }
		},

		_tryToSync: function(data){
                    ap_showWaitMessage('waitDiv', 1);
                    getGoogleAuthUrl('users', function (response) {
                        this.syncGoogleAuthUrlAvailable = true;
                        this.syncGoogleAuthUrl = response.url;

                        new Ajax.Request('aclpbx/index.php', {
                            method: 'post',
                            parameters: $H({
                                action: 'try_google_domainusers',
                                token: $H(data.token).toJSON()
                            }).toQueryString(),
                            onComplete: function(transport){
                                ap_showWaitMessage('waitDiv', 0);
                                if ("responseJSON" in transport && "users" in transport.responseJSON) {
                                    var response = transport.responseJSON;

                                    if (data.userInfo) {
                                        $('u_s_backend_google_mail').value = data.userInfo.email;
                                        $('u_s_backend_google_mail_text').innerHTML = data.userInfo.email;
                                    }

                                    $('u_s_backend_google_received_token_time').value = response.token.received_token_time;
                                    $('u_s_backend_google_access_token').value = response.token.access_token;
                                    $('u_s_backend_google_token_type').value = response.token.token_type;
                                    $('u_s_backend_google_expires_in').value = response.token.expires_in;
                                    $('u_s_backend_google_refresh_token').value = response.token.refresh_token;

                                    $('u_s_backend_google_logout').show();
                                    $('u_s_backend_google_login').hide();
                                } else if ("error" in transport.responseJSON && "message" in transport.responseJSON.error) {
                                    if (data && data.token && data.token.access_token) {
                                        setError('error', transport.responseJSON.error.message);
                                    }
                                }
                            }.bind(this)
                        });
                    }.bind(this), function (response) {
                        ap_showWaitMessage('waitDiv', 0);
                        setError('error', 'Cannot fetch Google Auth url');
                    });

                },

		uSyncToggleRecurrentJob: function(el,id1,id2){
		    this.uSyncToggleMapAttr(el,id1);
		    this.uSyncToggleMapAttr(el,id2);
		},

		uSyncToggleMapAttr: function(el,id){
		    $(id)[el.checked? 'enable': 'disable']();
		    el.value = el.checked? 1: 0;
		},

		usSyncSetFrom: function(trSettings){
		    var oBackend = $('u_s_backend_backend');
		    $H({'ldap':'LDAP','activeD':'Active Directory','domino':'Lotus Domino','mysql':'MySQL','mssql':'MSSQL','office365':'Office365','google':'Google','csv':'CSV','zohoCrm':'Zoho'}).each(function(val){
		        oBackend.options[oBackend.options.length] = new Option(val.value,val.key);
		    });

		    oBackend = $('us_recurrent_interval');
		    $H({'1':'1','2':'2','6':'6','12':'12','24':'24'}).each(function(val){
		        oBackend.options[oBackend.options.length] = new Option(val.value,val.key);
		    });

		    this.uSyncCurrBackend = this.usSyncSettingsAndMap['global']['backend'];
		    $('u_s_backend_backend').value = this.uSyncCurrBackend;

		    $('u_s_global_remove_users').checked = false;
		    $('u_s_global_erase_values').checked = false;
		    if (this.usSyncSettingsAndMap['global']['remove_users'] == 'yes'){
		        $('u_s_global_remove_users').checked = true;
		    }
		    if (this.usSyncSettingsAndMap['global']['erase_values'] == 'yes'){
		        $('u_s_global_erase_values').checked = true;
		    }

		    var t_filter = '(&(objectCategory=person)(objectClass=user)(!(userAccountControl:1.2.840.113556.1.4.803:=2)))';
		    var t_options = new Array(this.usSyncSettingsAndMap['settings']['ldap']['filter']);
		    if (this.usSyncSettingsAndMap['settings']['ldap']['filter'] != t_filter) t_options.push(t_filter);
		    oBackend = $('u_s_backend_ldap_filter');
		    $A(t_options).each(function(val){
		        //oBackend.options[oBackend.options.length] = new Option(val,val);
		    });

		    var t_filter = '(&(objectCategory=person)(objectClass=user)(!(userAccountControl:1.2.840.113556.1.4.803:=2)))';
		    var t_options = new Array(this.usSyncSettingsAndMap['settings']['activeD']['filter']);
		    if (this.usSyncSettingsAndMap['settings']['activeD']['filter'] != t_filter) t_options.push(t_filter);
		    oBackend = $('u_s_backend_activeD_filter');
		    $A(t_options).each(function(val){
		        //oBackend.options[oBackend.options.length] = new Option(val,val);
		    });

		    t_filter = 'SELECT ${MAP} FROM `users_table` WHERE `type`="local"';
		    t_options = new Array(this.usSyncSettingsAndMap['settings']['mysql']['filter']);
		    if (this.usSyncSettingsAndMap['settings']['mysql']['filter'] != t_filter) t_options.push(t_filter);
		    oBackend = $('u_s_backend_mysql_filter');
		    $A(t_options).each(function(val){
		        //oBackend.options[oBackend.options.length] = new Option(val,val);
		    });

		    t_filter = 'SELECT ${MAP} FROM [users_table] WHERE [type]=\'local\'';
		    t_options = new Array(this.usSyncSettingsAndMap['settings']['mssql']['filter']);
		    if (this.usSyncSettingsAndMap['settings']['mssql']['filter'] != t_filter) t_options.push(t_filter);
		    oBackend = $('u_s_backend_mssql_filter');
		    $A(t_options).each(function(val){
		        //oBackend.options[oBackend.options.length] = new Option(val,val);
		    });

		    oBackend = $('u_s_backend_csv_import_mountpoint');
		    $H(cSyncMounts).each(function(pair){
		        oBackend.options[oBackend.options.length] = new Option(pair.value,pair.key);
		    });

		    // IE !! rrrr
		    $('us_map_cn_on').disabled = true;
		    $('us_map_sourceId_on').disabled = true;

                    $A(['ldap','activeD','domino','mysql','mssql','office365','google','csv']).each(function(backend){
                        this.uSyncPlaceSyncSettings(backend);
		    }.bind(this));

		    this.uSyncPlaceSyncMap(this.uSyncCurrBackend);
		    this.uSyncPlaceSyncRecurrentJob();
		    this.uSyncChangeBackend(this.uSyncCurrBackend);
		    this.uSyncChangeCsvImportType($F('u_s_backend_csv_import_type'));
		},

		uSyncPlaceSyncSettings: function(backend){
			if(backend == 'google' && ('default' in this.usSyncSettingsAndMap) && (backend in this.usSyncSettingsAndMap['default']['settings'])){
				$H(this.usSyncSettingsAndMap['default']['settings'][backend]).each(function(pair){
					if(!this.usSyncSettingsAndMap['settings'][backend]){
                        this.usSyncSettingsAndMap['settings'][backend] = {};
					}
					if(!this.usSyncSettingsAndMap['settings'][backend][pair.key]){
						this.usSyncSettingsAndMap['settings'][backend][pair.key] = pair.value;
					}
				}.bind(this));
			}
		    $H(this.usSyncSettingsAndMap['settings'][backend]).each(function(pair){
                if($('u_s_backend_'+backend+'_'+pair.key+'').type == 'checkbox'){
		    		$('u_s_backend_'+backend+'_'+pair.key+'').checked = (pair.value == 'yes');
		    	}else{
		    		$('u_s_backend_'+backend+'_'+pair.key+'').value = pair.value;
		    	}
		    });
		},

		uSyncChangeCsvImportType: function(val) {
		    if (val == 'share') {
		        $('u_s_backend_csv_import_type_upload').hide();
		        $('u_s_backend_csv_import_type_share').show();
		    }else{
		        $('u_s_backend_csv_import_type_upload').show();
		        $('u_s_backend_csv_import_type_share').hide();
		    }
		},

		uSyncPlaceSyncMap: function(backend){
		    // disable all here
			var def = {};
			if(('default' in this.usSyncSettingsAndMap) && (backend in this.usSyncSettingsAndMap['default']['map'])){
				def = this.usSyncSettingsAndMap['default']['map'][backend];
			}

		    $A(this.usSyncFields).each(function(val){
		        $('us_map_'+val+'').value = def[val] || '';
		        $('us_map_'+val+'').disabled = true;
		        $('us_map_'+val+'_on').value = '0';
		        $('us_map_'+val+'_on').checked = false;
		    });
		    $H(this.usSyncSettingsAndMap['map'][backend]).each(function(pair){
		        $('us_map_'+pair.key+'').value = pair.value;
		        $('us_map_'+pair.key+'').disabled = false;
		        $('us_map_'+pair.key+'_on').value = '1';
		        $('us_map_'+pair.key+'_on').checked = true;
		    });

		    //leverage for zoho.
            if (backend === 'zohoCrm') {
                $('us_map_sourceId').disabled = true;
            }
		},

		uSyncPlaceSyncRecurrentJob: function(){
		    if (this.usSyncSettingsAndMap['recurrent_job']['enabled'] == 'yes'){
		        $('us_recurrent_on').checked = true;
		        $('us_recurrent_on').value = 1;
		        $('us_recurrent_interval').disabled = false;
		        $('us_recurrent_interval').value = this.usSyncSettingsAndMap['recurrent_job']['interval'];
		        $('us_recurrent_email').disabled = false;
		        $('us_recurrent_email').value = this.usSyncSettingsAndMap['recurrent_job']['email'];
		    }else{
		        $('us_recurrent_on').checked = false;
		        $('us_recurrent_on').value = 0;
		        $('us_recurrent_interval').value = '1';
		        $('us_recurrent_interval').disabled = true;
		        $('us_recurrent_email').value = '';
		        $('us_recurrent_email').disabled = true;
		    }
		},

		uSyncChangeBackend: function(backend){
		    // set this.usSyncSettingsAndMap['map'][this.uSyncCurrBackend]
		    $A(this.usSyncFields).each(function(val){
		        if ($('us_map_'+val+'_on').checked && $F('us_map_'+val) != ''){
		            this.usSyncSettingsAndMap['map'][this.uSyncCurrBackend][val] = $F('us_map_'+val+'');
		        }else{
		            //delete this.usSyncSettingsAndMap['map'][this.uSyncCurrBackend][val];
		        }
		    }.bind(this));
		    this.uSyncCurrBackend = backend;
		    $$('#users_sync_backend_settings tr.u_s_backend_ldap').invoke('hide');
		    $$('#users_sync_bottom tr.u_s_backend_ldap').invoke('hide');

		    $$('#users_sync_backend_settings tr.u_s_backend_activeD').invoke('hide');
		    $$('#users_sync_bottom tr.u_s_backend_activeD').invoke('hide');

            $$('#users_sync_backend_settings tr.u_s_backend_domino').invoke('hide');
            $$('#users_sync_bottom tr.u_s_backend_domino').invoke('hide');

		    $$('#users_sync_backend_settings tr.u_s_backend_mysql').invoke('hide');
		    $$('#users_sync_bottom tr.u_s_backend_mysql').invoke('hide');

		    $$('#users_sync_backend_settings tr.u_s_backend_mssql').invoke('hide');
		    $$('#users_sync_bottom tr.u_s_backend_mssql').invoke('hide');

		    $$('#users_sync_backend_settings tr.u_s_backend_office365').invoke('hide');
		    $$('#users_sync_bottom tr.u_s_backend_office365').invoke('hide');
            $$('#users_sync_backend_settings tr.u_s_hint_office365').invoke('hide');

		    $$('#users_sync_backend_settings tr.u_s_backend_google').invoke('hide');
		    $$('#users_sync_bottom tr.u_s_backend_google').invoke('hide');
            $$('#users_sync_backend_settings tr.u_s_hint_google').invoke('hide');
            $$('#users_sync_backend_settings tr.u_s_hint_zohoCrm').invoke('hide');

		    $$('#users_sync_backend_settings tr.u_s_backend_csv').invoke('hide');
		    $$('#users_sync_bottom tr.u_s_backend_csv').invoke('hide');

            $$('#users_sync_backend_settings tr.u_s_backend_zohoCrm').invoke('hide');
            $$('#users_sync_bottom tr.u_s_backend_zohoCrm').invoke('hide');

		    if(backend == 'csv' && (this.varsPhp.is_wcloud || ! $H(cSyncMounts).size())){
		    	$$('#users_sync_recurrent').invoke('hide');
		    	$('us_recurrent_on').checked = false;
		    }
		    else{
		    	$$('#users_sync_recurrent').invoke('show');
		    }

		    if(backend == 'office365'){
		    	var settings = this.usSyncSettingsAndMap['settings'][backend];

		    	this._onOffice365LoadToken({token: {
		    		'access_token': settings.access_token,
		    		'expires_in': settings.expires_in,
		    		'received_token_time': settings.received_token_time,
		    		'id_token': settings.id_token,
		    		'id_token_expires_in': settings.id_token_expires_in,
		    		'refresh_token': settings.refresh_token,
		    		'token_type': settings.token_type
		    	},
                userInfo: {
                	preferred_username: settings.mail
                }});
		    }

		    if(backend == 'zohoCrm'){
		    	var settings = this.usSyncSettingsAndMap['settings'][backend];

				if (settings) {
                    this._onZohoCrmLoadToken({
                        token: {
                            'access_token': settings.access_token,
                            'expires_in': settings.expires_in,
                            'received_token_time': settings.received_token_time,
                            'refresh_token': settings.refresh_token,
                            'token_type': settings.token_type,
                            'api_domain': settings.api_domain,
                            'location': settings.location,
                            'accounts_server': settings.accounts_server
                        },
                        userInfo: {
                            full_name: settings.full_name
                        }
                    });
                }
		    }

		    if (backend == 'google') {
		    	var settings = this.usSyncSettingsAndMap['settings'][backend] || {};

		    	this._tryToSync({token: {
                            'access_token': settings.access_token,
                            'expires_in': settings.expires_in,
                            'received_token_time': settings.received_token_time,
                            'refresh_token': settings.refresh_token,
                            'token_type': settings.token_type
		    			},
                        userInfo: {
                            email: settings.mail
                        }});
		    }

		    $$('#users_sync_backend_settings tr.u_s_backend_'+backend).invoke('show');
		    $$('#users_sync_backend_settings tr.u_s_hint_'+backend).invoke('show');
		    $$('#users_sync_bottom tr.u_s_backend_'+backend).invoke('show');
		    this.uSyncPlaceSyncMap(backend);
		},

		uSyncBack: function(el) {
		    this.uSyncUpdater.stop();
		    $('users_sync_settings_div').show();
		    $('users_sync_log_div').update('&nbsp');
		    $('users_sync_log_div').hide();
		    $('users_sync_div_buttons_settings').show();
		    $('users_sync_div_buttons_test').hide();
		},

		uSyncDoSave: function() {

		    var t_backend = $F('u_s_backend_backend');
		    var go_settings = {"global":{"backend":t_backend,"remove_users":"no","erase_values":"no"}};

		    if ($('u_s_global_remove_users').checked){
		        go_settings['global']['remove_users'] = 'yes';
		    }
		    if ($('u_s_global_erase_values').checked){
		        go_settings['global']['erase_values'] = 'yes';
		    }

		    $$('span.err_span').invoke('remove');
		    // no recurrent job for csv
		    if (t_backend == 'csv' && $('us_recurrent_on').checked && $F('u_s_backend_csv_import_type') == 'upload'){
		        raiseErrors({'us_recurrent_on':gl_translation['aclpbx.noRecurrentSyncForCsv']});
		        return false;
		    }
		    // check share is present for csv
		    if (t_backend == 'csv' && $F('u_s_backend_csv_import_type') == 'share' && ! $F('u_s_backend_csv_import_mountpoint')){
		        raiseErrors({'u_s_backend_csv_import_mountpoint':gl_translation['rules.enterValidValue']},' ');
		        return false;
		    }

		    $A(['ldap','activeD','domino','mysql','mssql','office365','google','csv', 'zohoCrm']).each(function(backend){
		        go_settings[backend] = this.uSyncReadSettings(backend);
		        if (t_backend != backend){
		            go_settings[backend]['map'] = this.usSyncSettingsAndMap['map'][backend];
		        }
		    }.bind(this));

		    go_settings['recurrent_job'] = {};
		    if ($('us_recurrent_on').checked){
		        go_settings['recurrent_job']['enabled'] = 'yes';
		        go_settings['recurrent_job']['interval'] = $F('us_recurrent_interval');
		        go_settings['recurrent_job']['email'] = $F('us_recurrent_email');
		    }else{
		        go_settings['recurrent_job']['enabled'] = 'no';
		    }

		    ap_showWaitMessage('waitDiv', 1);
		    return new Ajax.Request('aclpbx/index.php',{
		        method: 'post',
		        parameters:$H({
		            "action": 'users_sync_save',
		            "settings": $H(go_settings).toJSON()
		        }).toQueryString(),
		        onComplete: function(transport){
		            // fixme: may be error(s) in resp?
		        	this.usSyncSettingsAndMap = transport.responseJSON;
		            ap_showWaitMessage('waitDiv', 0);
		        }.bind(this)
		    });

		},

		uSyncReadSettings: function(backend){
		    var t_settings = {'backend': backend};
		    $H(this.usSyncSettingsAndMap['settings'][backend]).each(function(pair){
		        t_settings[pair.key] = $F('u_s_backend_'+backend+'_'+pair.key+'');
		    });
		    // get map
		    var t_map = {}
		    $A(this.usSyncFields).each(function(val){
		        if ($('us_map_'+val+'_on').checked && $F('us_map_'+val) != ''){
		            t_map[val] = $F('us_map_'+val+'');
		        }
		    });
		    return {'settings': t_settings, 'map': t_map};
		},

		uSyncDoSync: function(dry_run,verbose) {

		    var syncid = Math.random().toString().substring(3,8);
		    var backend = $F('u_s_backend_backend');
		    var go_settings = this.uSyncReadSettings(backend);

			//save setting
			this.uSyncDoSave.bind(this)();

		    go_settings['global'] = {"remove_users":"no","erase_values":"no"};
		    if ($('u_s_global_remove_users').checked){
		        go_settings['global']['remove_users'] = 'yes';
		    }
		    if ($('u_s_global_erase_values').checked){
		        go_settings['global']['erase_values'] = 'yes';
		    }

		    $$('span.err_span').invoke('remove');
		    // check share is present for csv
		    if (backend == 'csv' && $F('u_s_backend_csv_import_type') == 'share' && ! $F('u_s_backend_csv_import_mountpoint')){
		        raiseErrors({'u_s_backend_csv_import_mountpoint':gl_translation['rules.enterValidValue']},' ');
		        return false;
		    }

		    if (go_settings['settings']['backend'] == 'csv' && $F('u_s_backend_csv_import_type') == 'upload'){
		        go_settings['dry_run'] = dry_run;
		        go_settings['verbose'] = verbose;
		        go_settings['syncid'] = syncid;
		        $('u_s_backend_csv_params').name = 'u_s_backend_csv_params';
		        $('u_s_backend_csv_params').value = $H(go_settings).toJSON();
		        var form = $('users_sync_backend_settings_filter_form');
		        var rez = AIM.submit(
		            form,
		            {
		                'onStart' : this.uSyncUplCsvStartCallback,
		                'onComplete' : function(response){
		                    if(response !== ''){
		                        oResponse = eval("(" + response + ")");
		                        if(oResponse === true){
		                            this.uSyncStartShowLog(syncid);
		                        }else if (oResponse.ERRORS){
		                            ap_showWaitMessage('waitDiv', 0);
		                            raiseErrors({'u_s_backend_csv_fileid':oResponse.ERRORS}, ' ');
		                        }else{
		                            ap_showWaitMessage('waitDiv', 0);
		                            raiseErrors(oResponse,' ');
		                        }
		                    }else{
		                        ap_showWaitMessage('waitDiv', 0);
		                        raiseErrors({'u_s_backend_csv_fileid':'Upload error'},' ');
		                    }
		                }.bind(this)
		            }
		        );
		        if (!rez){
		            return false;
		        }else{
		            form.submit();
		            return true;
		        }
		    }

		    ap_showWaitMessage('waitDiv', 1);
		    return new Ajax.Request('aclpbx/index.php',{
		        method: 'post',
		        parameters:$H({
		            "action": 'users_sync',
		            "dry_run": dry_run,
		            "verbose": verbose,
		            "syncid": syncid,
		            "settings": $H(go_settings).toJSON()
		        }).toQueryString(),
		        onComplete: function(transport){
		            this.uSyncStartShowLog(syncid);
		        }.bind(this)
		    });
		},

		uSyncStartShowLog: function(syncid){

			$('users_sync_settings_div').hide();
		    $('users_sync_log_div').update('&nbsp');
		    $('users_sync_log_div').show();
		    $('users_sync_div_buttons_settings').hide();
		    $('users_sync_div_buttons_test').show();
		    $('us_btn_back').disable();

		    ap_showWaitMessage('waitDiv', 0);

		    this.uSyncUpdater = new Ajax.PeriodicalUpdater (false/* stop */,'monit/log/?act=show_users_sync&syncid='+syncid, {
		        method: 'get', frequency: 2, decay: 1,
		        onSuccess: function(t) {
		            if (t.status == '200') {
		                if (t.responseText != ''){
		                    var t_arr = t.responseText.split("\n");
		                    var t_completed = false;
		                    for (var t_cnt = 0, t_length = t_arr.length; t_cnt < t_length; t_cnt++){
		                        if (t_arr[t_cnt].indexOf('The operation is completed.') != -1 || t_arr[t_cnt].indexOf('No change was provided.') != -1){
		                            t_completed = true;
		                        }
		                    }
		                    $('users_sync_log_div').update(t_arr.join("<br /><br />") + (t_completed?"":'<div style="background-color:#233259;color:#d5d5d3;font-size:11px;height:20px;font-weight:bold">'+ gl_translation['strings.Proceeding'] + '...</div>'));
		                    t_arr = null;
		                    if (t_completed){
		                    	this.getLicenseUsageStatus();
		                        this.uSyncUpdater.stop();
		                        $('us_btn_back').enable();
                                dispatchEvent(new Event('userFormSaved'));
		                    }
		                }
		            }
		        }.bind(this)
		    });
		},


		uSyncUplCsvStartCallback: function(){
		    $$('span.err_span').invoke('remove');
		    ok = $A(['u_s_backend_csv_fileid']).inject([],function(a,n){
		        if($(n).value != '') a.push($(n).value);
		        return a;
		    }).all(function(value){
		        return ['.csv'].any(function(extension){
		            return value.endsWith(extension.toLowerCase());
		        });
		    });
		    if(!ok || $F('u_s_backend_csv_fileid') == ''){
		        raiseErrors({'u_s_backend_csv_fileid':'Valid format: csv'},' ');
		        ap_showWaitMessage('waitDiv', 0);
		        return false;
		    } else {
		        return true;
		    }
		},

		showDialog: function(width, height, content, functionOk, buttons, noEnter, functionCancel){
			this.modwin = new UI.Window($H({
				width: width,
				resizable:false,
				height: height,
				shadow: false,
				superflousEffects : false,
				theme: 'bluelighting'
			}).toObject())
			.setContent(content)
			.center({ auto: true })

			if( ! buttons){
				this.modwin.prefoot.innerHTML = '<input id="saveUserButOk" type="button" value="'+(gl_translation['button.Ok'] || 'Ok')+'" class="but20" />\
				<input id="saveUserButCancel" type="button" value="'+(gl_translation['button.Cancel'] || 'Cancel')+'" class="but20" />';
			}else{
				this.modwin.prefoot.innerHTML = buttons;
			}

			this.modwin.show(true).focus();

			if(functionOk){
				$('saveUserButOk').onclick = functionOk.bind(this);
				this.modwin.content.onkeyup = function(event) {
					if(event.keyCode==13 && !noEnter) {
						functionOk.apply(this);
					}
				}.bind(this);
			}

            if(functionCancel) {
                $('saveUserButCancel').onclick = functionCancel.bind(this);
            }
			$('saveUserButCancel').onmouseup = function(){
				this.modwin.close();
                this.modwin = null;
			}.bind(this);

			return this.modwin;
		},

        showSecondDialog: function(width, height, content, functionOk, buttons, noEnter){
            this.modsecwin = new UI.Window($H({
                width: width,
                resizable:false,
                height: height,
                shadow: false,
                superflousEffects : false,
                theme: 'bluelighting'
            }).toObject())
                .setContent(content)
                .center({ auto: true });

            if( ! buttons){
                this.modsecwin.prefoot.innerHTML = '<input id="pressUserButOk" type="button" value="'+(gl_translation['button.Ok'] || 'Ok')+'" class="but20" />\
				<input id="pressUserButCancel" type="button" value="'+(gl_translation['button.Cancel'] || 'Cancel')+'" class="but20" />';
            }else{
                this.modsecwin.prefoot.innerHTML = buttons;
            }

            this.modsecwin.show(true).focus();

            if(functionOk){
                $('pressUserButOk').onclick = functionOk.bind(this);
                this.modsecwin.content.onkeyup = function(event) {
                    if(event.keyCode==13 && !noEnter) {
                        functionOk.apply(this);
                    }
                }.bind(this);
            }

            $('pressUserButCancel').onclick = function(){
                this.modsecwin.close();
                this.modsecwin = null;
            }.bind(this);

            return this.modsecwin;
        },
		getLicenseUsageStatus: function () {
			new Ajax.Request('aclpbx/index.php',{
				method: 'post',
				parameters:$H({
					"action": 'getLicenseUsageStatus'
				}).toQueryString(),
				onComplete: function (response) {
					const res = response.responseText;
					if (res !== 'OK') {
						setError('error', res);
					}
				}.bind(this)
			});
		},

		doESC: Prototype.emptyFunction
	});

	if(YAHOO.util.EventProvider) {
		YAHOO.augment(WMS.Users, YAHOO.util.EventProvider);
	}
}
